# Welcome to the bhyve hack of kvm-unit-tests

See http://www.linux-kvm.org/page/KVM-unit-tests for a high-level
description of this project, as well as running tests and adding
tests HOWTOs.

# Building the tests

Install required ports

    pkg install gcc
    pkg install bash
    pkg install gmake


To create the test images,

    ./configure --arch=x86_64 --objcopy=/usr/local/bin/objcopy
    gmake

Test images are created in ./ARCH/\*.flat

# Running the tests

Install the grub bhyve port

    pkg install grub2-bhyve

The tests can be loaded with grub-bhyve

    grub-bhyve -M 256M kvmtest
    multiboot /path/to/repo/x86/realmode.flat
    boot

and then run with bhyve. The '-D' option is used to delete the VM on exit in this case;
makes it easier to run a new test.

    bhyve \
      -c 1  -s 3,lpc \
      -s 0,hostbridge \
      -l com1,stdio \
      -D -H -m 256M kvmtest

# Unit test inputs

Key/value pairs can be appended to the end of the multiboot command line e.g.

    multiboot /path/to/repo/x86/realmode.flat dummy KEY=val KEY2=val

The 'dummy' parameter that is to workaround grub's ordering of parameters.

Unit tests use QEMU's '-append args...' parameter for command line
inputs, i.e. all args will be available as argv strings in main().
Additionally a file of the form

    KEY=VAL
    KEY2=VAL
    ...

may be passed with '-initrd file' to become the unit test's environ,
which can then be accessed in the usual ways, e.g. VAL = getenv("KEY").
Any key=val strings can be passed, but some have reserved meanings in
the framework.  The list of reserved environment variables is below

    QEMU_ACCEL                   either kvm, hvf or tcg
    QEMU_VERSION_STRING          string of the form `qemu -h | head -1`
    KERNEL_VERSION_STRING        string of the form `uname -r`

Additionally these self-explanatory variables are reserved

    QEMU_MAJOR, QEMU_MINOR, QEMU_MICRO, KERNEL_VERSION, KERNEL_PATCHLEVEL,
    KERNEL_SUBLEVEL, KERNEL_EXTRAVERSION
